﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;


[Serializable]
[Microsoft.SqlServer.Server.SqlUserDefinedAggregate(Format.Native)]
public struct Aggregate1
{
    public void Init()
    {
        this.theCount = 0;  // << 
    }

    public void Accumulate(SqlString Value)
    {
        if (Value.IsNull)   // << 
        {
            this.theCount++;
        }
    }

    public void Merge(Aggregate1 Group)
    {
        this.theCount += Group.theCount;  // << 
    }

    public SqlInt32 Terminate()
    {
        return this.theCount;  // << 
    }

    private int theCount;
}