
-- check ob 'clr enabled' = 1

Select *
From   sys.configurations
Where  name = 'clr enabled'

------
-- sonst
exec sp_configure 'clr enabled', 1
GO
RECONFIGURE
GO

--============================

CREATE DATABASE netUG_Frankfurt

USE netUG_Frankfurt --N'<database_name, sysname, sample_database>'
go

--ALTER DATABASE N'<database_name, sysname, sample_database>' 
--SET Trustworthy ON
--
--  >> oder Signieren der Assembly!
-- und
-- der Datenbankbesitzer (DBO) hat die EXTERNAL_ACCESS ASSEMBLY-Berechtigung, 
--  = Voraussetzung fr Permission_Set = External_Access


--Select name, is_trustworthy_on
--From   sys.databases

-- Registrieren der Assembly 

CREATE ASSEMBLY sql_fx_Aggregate
FROM 'C:\_myProg\SQL_CLR\SqlServerProject1\SqlServerProject1\bin\Debug\SqlServerProject1.dll'
WITH Permission_Set = Safe

-- berprfung
SELECT * FROM sys.assemblies;
SELECT * FROM sys.assembly_files;
SELECT * FROM sys.assembly_modules;
SELECT * FROM sys.assembly_references;

-- erstellen der Aggregate-fx aus der Assembly

CREATE Aggregate countNull(@Value nvarchar(4000))
RETURNS int
EXTERNAL Name  sql_fx_Aggregate.Aggregate1

------------------------------------------------
--  UserDefinedAggregates
--  CountNullValues

CREATE Table dbo.test_NullValues  (
               vorname    varChar(50)
             , nachname   varChar(50)
             )
GO
----
             
INSERT   dbo.test_NullValues
       ( vorname , nachname )
VALUES ( 'Anton' , 'Mller' )
     , ( 'Berti' , 'Meier'  )                
     , ( 'Clausi',  null    )
     , ( 'Daniel',  null    )
     , ( 'Emil'  ,  null    )
     , (  null   ,  null    )
     , (  null   , 'Mustermann' )
     , (  null   , 'Musterfrau' )
     , (  null   , 'Musterkind' )
GO
----     


Select count(*)                As [count_All]
     , count(vorname)          As [countVorname]
     , dbo.countNull(vorname)  As [countNull]
From   dbo.test_NullValues     


--------------
-- berwachen mit dyn. Management Views

Select *
From   sys.dm_clr_appdomains
----
Select *
From   sys.dm_clr_loaded_assemblies
----
Select *
From   sys.dm_clr_properties
----
Select *
From   sys.dm_clr_tasks



--============================================